/**
 * Autogenerated by Thrift
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 */
package org.apache.hadoop.hive.metastore.api;

import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import org.apache.thrift.*;
import org.apache.thrift.async.*;
import org.apache.thrift.meta_data.*;
import org.apache.thrift.transport.*;
import org.apache.thrift.protocol.*;

public class HiveObjectRef implements TBase<HiveObjectRef, HiveObjectRef._Fields>, java.io.Serializable, Cloneable {
  private static final TStruct STRUCT_DESC = new TStruct("HiveObjectRef");

  private static final TField OBJECT_TYPE_FIELD_DESC = new TField("objectType", TType.I32, (short)1);
  private static final TField DB_NAME_FIELD_DESC = new TField("dbName", TType.STRING, (short)2);
  private static final TField OBJECT_NAME_FIELD_DESC = new TField("objectName", TType.STRING, (short)3);
  private static final TField PART_VALUES_FIELD_DESC = new TField("partValues", TType.LIST, (short)4);
  private static final TField COLUMN_NAME_FIELD_DESC = new TField("columnName", TType.STRING, (short)5);

  private HiveObjectType objectType;
  private String dbName;
  private String objectName;
  private List<String> partValues;
  private String columnName;

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements TFieldIdEnum {
    /**
     * 
     * @see HiveObjectType
     */
    OBJECT_TYPE((short)1, "objectType"),
    DB_NAME((short)2, "dbName"),
    OBJECT_NAME((short)3, "objectName"),
    PART_VALUES((short)4, "partValues"),
    COLUMN_NAME((short)5, "columnName");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // OBJECT_TYPE
          return OBJECT_TYPE;
        case 2: // DB_NAME
          return DB_NAME;
        case 3: // OBJECT_NAME
          return OBJECT_NAME;
        case 4: // PART_VALUES
          return PART_VALUES;
        case 5: // COLUMN_NAME
          return COLUMN_NAME;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments

  public static final Map<_Fields, FieldMetaData> metaDataMap;
  static {
    Map<_Fields, FieldMetaData> tmpMap = new EnumMap<_Fields, FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.OBJECT_TYPE, new FieldMetaData("objectType", TFieldRequirementType.DEFAULT, 
        new EnumMetaData(TType.ENUM, HiveObjectType.class)));
    tmpMap.put(_Fields.DB_NAME, new FieldMetaData("dbName", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.OBJECT_NAME, new FieldMetaData("objectName", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.STRING)));
    tmpMap.put(_Fields.PART_VALUES, new FieldMetaData("partValues", TFieldRequirementType.DEFAULT, 
        new ListMetaData(TType.LIST, 
            new FieldValueMetaData(TType.STRING))));
    tmpMap.put(_Fields.COLUMN_NAME, new FieldMetaData("columnName", TFieldRequirementType.DEFAULT, 
        new FieldValueMetaData(TType.STRING)));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    FieldMetaData.addStructMetaDataMap(HiveObjectRef.class, metaDataMap);
  }

  public HiveObjectRef() {
  }

  public HiveObjectRef(
    HiveObjectType objectType,
    String dbName,
    String objectName,
    List<String> partValues,
    String columnName)
  {
    this();
    this.objectType = objectType;
    this.dbName = dbName;
    this.objectName = objectName;
    this.partValues = partValues;
    this.columnName = columnName;
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public HiveObjectRef(HiveObjectRef other) {
    if (other.isSetObjectType()) {
      this.objectType = other.objectType;
    }
    if (other.isSetDbName()) {
      this.dbName = other.dbName;
    }
    if (other.isSetObjectName()) {
      this.objectName = other.objectName;
    }
    if (other.isSetPartValues()) {
      List<String> __this__partValues = new ArrayList<String>();
      for (String other_element : other.partValues) {
        __this__partValues.add(other_element);
      }
      this.partValues = __this__partValues;
    }
    if (other.isSetColumnName()) {
      this.columnName = other.columnName;
    }
  }

  public HiveObjectRef deepCopy() {
    return new HiveObjectRef(this);
  }

  @Override
  public void clear() {
    this.objectType = null;
    this.dbName = null;
    this.objectName = null;
    this.partValues = null;
    this.columnName = null;
  }

  /**
   * 
   * @see HiveObjectType
   */
  public HiveObjectType getObjectType() {
    return this.objectType;
  }

  /**
   * 
   * @see HiveObjectType
   */
  public void setObjectType(HiveObjectType objectType) {
    this.objectType = objectType;
  }

  public void unsetObjectType() {
    this.objectType = null;
  }

  /** Returns true if field objectType is set (has been asigned a value) and false otherwise */
  public boolean isSetObjectType() {
    return this.objectType != null;
  }

  public void setObjectTypeIsSet(boolean value) {
    if (!value) {
      this.objectType = null;
    }
  }

  public String getDbName() {
    return this.dbName;
  }

  public void setDbName(String dbName) {
    this.dbName = dbName;
  }

  public void unsetDbName() {
    this.dbName = null;
  }

  /** Returns true if field dbName is set (has been asigned a value) and false otherwise */
  public boolean isSetDbName() {
    return this.dbName != null;
  }

  public void setDbNameIsSet(boolean value) {
    if (!value) {
      this.dbName = null;
    }
  }

  public String getObjectName() {
    return this.objectName;
  }

  public void setObjectName(String objectName) {
    this.objectName = objectName;
  }

  public void unsetObjectName() {
    this.objectName = null;
  }

  /** Returns true if field objectName is set (has been asigned a value) and false otherwise */
  public boolean isSetObjectName() {
    return this.objectName != null;
  }

  public void setObjectNameIsSet(boolean value) {
    if (!value) {
      this.objectName = null;
    }
  }

  public int getPartValuesSize() {
    return (this.partValues == null) ? 0 : this.partValues.size();
  }

  public java.util.Iterator<String> getPartValuesIterator() {
    return (this.partValues == null) ? null : this.partValues.iterator();
  }

  public void addToPartValues(String elem) {
    if (this.partValues == null) {
      this.partValues = new ArrayList<String>();
    }
    this.partValues.add(elem);
  }

  public List<String> getPartValues() {
    return this.partValues;
  }

  public void setPartValues(List<String> partValues) {
    this.partValues = partValues;
  }

  public void unsetPartValues() {
    this.partValues = null;
  }

  /** Returns true if field partValues is set (has been asigned a value) and false otherwise */
  public boolean isSetPartValues() {
    return this.partValues != null;
  }

  public void setPartValuesIsSet(boolean value) {
    if (!value) {
      this.partValues = null;
    }
  }

  public String getColumnName() {
    return this.columnName;
  }

  public void setColumnName(String columnName) {
    this.columnName = columnName;
  }

  public void unsetColumnName() {
    this.columnName = null;
  }

  /** Returns true if field columnName is set (has been asigned a value) and false otherwise */
  public boolean isSetColumnName() {
    return this.columnName != null;
  }

  public void setColumnNameIsSet(boolean value) {
    if (!value) {
      this.columnName = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case OBJECT_TYPE:
      if (value == null) {
        unsetObjectType();
      } else {
        setObjectType((HiveObjectType)value);
      }
      break;

    case DB_NAME:
      if (value == null) {
        unsetDbName();
      } else {
        setDbName((String)value);
      }
      break;

    case OBJECT_NAME:
      if (value == null) {
        unsetObjectName();
      } else {
        setObjectName((String)value);
      }
      break;

    case PART_VALUES:
      if (value == null) {
        unsetPartValues();
      } else {
        setPartValues((List<String>)value);
      }
      break;

    case COLUMN_NAME:
      if (value == null) {
        unsetColumnName();
      } else {
        setColumnName((String)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case OBJECT_TYPE:
      return getObjectType();

    case DB_NAME:
      return getDbName();

    case OBJECT_NAME:
      return getObjectName();

    case PART_VALUES:
      return getPartValues();

    case COLUMN_NAME:
      return getColumnName();

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been asigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case OBJECT_TYPE:
      return isSetObjectType();
    case DB_NAME:
      return isSetDbName();
    case OBJECT_NAME:
      return isSetObjectName();
    case PART_VALUES:
      return isSetPartValues();
    case COLUMN_NAME:
      return isSetColumnName();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof HiveObjectRef)
      return this.equals((HiveObjectRef)that);
    return false;
  }

  public boolean equals(HiveObjectRef that) {
    if (that == null)
      return false;

    boolean this_present_objectType = true && this.isSetObjectType();
    boolean that_present_objectType = true && that.isSetObjectType();
    if (this_present_objectType || that_present_objectType) {
      if (!(this_present_objectType && that_present_objectType))
        return false;
      if (!this.objectType.equals(that.objectType))
        return false;
    }

    boolean this_present_dbName = true && this.isSetDbName();
    boolean that_present_dbName = true && that.isSetDbName();
    if (this_present_dbName || that_present_dbName) {
      if (!(this_present_dbName && that_present_dbName))
        return false;
      if (!this.dbName.equals(that.dbName))
        return false;
    }

    boolean this_present_objectName = true && this.isSetObjectName();
    boolean that_present_objectName = true && that.isSetObjectName();
    if (this_present_objectName || that_present_objectName) {
      if (!(this_present_objectName && that_present_objectName))
        return false;
      if (!this.objectName.equals(that.objectName))
        return false;
    }

    boolean this_present_partValues = true && this.isSetPartValues();
    boolean that_present_partValues = true && that.isSetPartValues();
    if (this_present_partValues || that_present_partValues) {
      if (!(this_present_partValues && that_present_partValues))
        return false;
      if (!this.partValues.equals(that.partValues))
        return false;
    }

    boolean this_present_columnName = true && this.isSetColumnName();
    boolean that_present_columnName = true && that.isSetColumnName();
    if (this_present_columnName || that_present_columnName) {
      if (!(this_present_columnName && that_present_columnName))
        return false;
      if (!this.columnName.equals(that.columnName))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    return 0;
  }

  public int compareTo(HiveObjectRef other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;
    HiveObjectRef typedOther = (HiveObjectRef)other;

    lastComparison = Boolean.valueOf(isSetObjectType()).compareTo(typedOther.isSetObjectType());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetObjectType()) {
      lastComparison = TBaseHelper.compareTo(this.objectType, typedOther.objectType);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetDbName()).compareTo(typedOther.isSetDbName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetDbName()) {
      lastComparison = TBaseHelper.compareTo(this.dbName, typedOther.dbName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetObjectName()).compareTo(typedOther.isSetObjectName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetObjectName()) {
      lastComparison = TBaseHelper.compareTo(this.objectName, typedOther.objectName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetPartValues()).compareTo(typedOther.isSetPartValues());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetPartValues()) {
      lastComparison = TBaseHelper.compareTo(this.partValues, typedOther.partValues);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetColumnName()).compareTo(typedOther.isSetColumnName());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetColumnName()) {
      lastComparison = TBaseHelper.compareTo(this.columnName, typedOther.columnName);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(TProtocol iprot) throws TException {
    TField field;
    iprot.readStructBegin();
    while (true)
    {
      field = iprot.readFieldBegin();
      if (field.type == TType.STOP) { 
        break;
      }
      switch (field.id) {
        case 1: // OBJECT_TYPE
          if (field.type == TType.I32) {
            this.objectType = HiveObjectType.findByValue(iprot.readI32());
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 2: // DB_NAME
          if (field.type == TType.STRING) {
            this.dbName = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 3: // OBJECT_NAME
          if (field.type == TType.STRING) {
            this.objectName = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 4: // PART_VALUES
          if (field.type == TType.LIST) {
            {
              TList _list4 = iprot.readListBegin();
              this.partValues = new ArrayList<String>(_list4.size);
              for (int _i5 = 0; _i5 < _list4.size; ++_i5)
              {
                String _elem6;
                _elem6 = iprot.readString();
                this.partValues.add(_elem6);
              }
              iprot.readListEnd();
            }
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        case 5: // COLUMN_NAME
          if (field.type == TType.STRING) {
            this.columnName = iprot.readString();
          } else { 
            TProtocolUtil.skip(iprot, field.type);
          }
          break;
        default:
          TProtocolUtil.skip(iprot, field.type);
      }
      iprot.readFieldEnd();
    }
    iprot.readStructEnd();
    validate();
  }

  public void write(TProtocol oprot) throws TException {
    validate();

    oprot.writeStructBegin(STRUCT_DESC);
    if (this.objectType != null) {
      oprot.writeFieldBegin(OBJECT_TYPE_FIELD_DESC);
      oprot.writeI32(this.objectType.getValue());
      oprot.writeFieldEnd();
    }
    if (this.dbName != null) {
      oprot.writeFieldBegin(DB_NAME_FIELD_DESC);
      oprot.writeString(this.dbName);
      oprot.writeFieldEnd();
    }
    if (this.objectName != null) {
      oprot.writeFieldBegin(OBJECT_NAME_FIELD_DESC);
      oprot.writeString(this.objectName);
      oprot.writeFieldEnd();
    }
    if (this.partValues != null) {
      oprot.writeFieldBegin(PART_VALUES_FIELD_DESC);
      {
        oprot.writeListBegin(new TList(TType.STRING, this.partValues.size()));
        for (String _iter7 : this.partValues)
        {
          oprot.writeString(_iter7);
        }
        oprot.writeListEnd();
      }
      oprot.writeFieldEnd();
    }
    if (this.columnName != null) {
      oprot.writeFieldBegin(COLUMN_NAME_FIELD_DESC);
      oprot.writeString(this.columnName);
      oprot.writeFieldEnd();
    }
    oprot.writeFieldStop();
    oprot.writeStructEnd();
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("HiveObjectRef(");
    boolean first = true;

    sb.append("objectType:");
    if (this.objectType == null) {
      sb.append("null");
    } else {
      sb.append(this.objectType);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("dbName:");
    if (this.dbName == null) {
      sb.append("null");
    } else {
      sb.append(this.dbName);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("objectName:");
    if (this.objectName == null) {
      sb.append("null");
    } else {
      sb.append(this.objectName);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("partValues:");
    if (this.partValues == null) {
      sb.append("null");
    } else {
      sb.append(this.partValues);
    }
    first = false;
    if (!first) sb.append(", ");
    sb.append("columnName:");
    if (this.columnName == null) {
      sb.append("null");
    } else {
      sb.append(this.columnName);
    }
    first = false;
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws TException {
    // check for required fields
  }

}

